Index: /trunk/LMDZ.GENERIC/libf/dyn3d/disvert.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/disvert.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/disvert.F	(revision 253)
@@ -1,3 +1,6 @@
       SUBROUTINE disvert 
+
+! to use  'getin'
+      USE ioipsl_getincom 
 
 c    Auteur :  F. Forget Y. Wanherdrick, P. Levan
@@ -11,4 +14,8 @@
 #include "comconst.h"
 #include "logic.h"
+
+#include "callkeys.h"
+
+
 c
 c=======================================================================
@@ -26,5 +33,5 @@
       REAL zsig(llm)
       INTEGER np,ierr
-      integer :: ierr1,ierr2,ierr3,ierr4
+      integer :: ierr1,ierr2,ierr3,ierr4 
       REAL x
 
@@ -39,4 +46,7 @@
       real z, ps,p
 
+
+      real psurf, hmax ! for autozlevs
+
 c
 c-----------------------------------------------------------------------
@@ -44,74 +54,53 @@
       pi=2.*ASIN(1.)
 
-! Ouverture possible de fichiers typiquement E.T.
-
-         open(99,file="esasig.def",status='old',form='formatted',
-     s   iostat=ierr2)
-         if(ierr2.ne.0) then
-              close(99)
-              open(99,file="z2sig.def",status='old',form='formatted',
-     s        iostat=ierr4)
-         endif
-
-c-----------------------------------------------------------------------
-c   cas 1 on lit les options dans esasig.def:
-c   ----------------------------------------
-
-      IF(ierr2.eq.0) then
-
-c        Lecture de esasig.def :
-c        Systeme peu souple, mais qui respecte en theorie
-c        La conservation de l'energie (conversion Energie potentielle
-c        <-> energie cinetique, d'apres la note de Frederic Hourdin...
-
-         PRINT*,'*****************************'
-         PRINT*,'WARNING Lecture de esasig.def'
-         PRINT*,'*****************************'
-         READ(99,*) h
-         READ(99,*) dz0
-         READ(99,*) dz1
-         READ(99,*) nhaut
-         CLOSE(99)
-
-         dz0=dz0/h
-         dz1=dz1/h
-
-         sig1=(1.-dz1)/tanh(.5*(llm-1)/nhaut)
-
-         esig=1.
-
-         do l=1,20
-            esig=-log((1./sig1-1.)*exp(-dz0)/esig)/(llm-1.)
-         enddo
-         csig=(1./sig1-1.)/(exp(esig)-1.)
-
-         DO L = 2, llm
-            zz=csig*(exp(esig*(l-1.))-1.)
-            sig(l) =1./(1.+zz)
-     &      * tanh(.5*(llm+1-l)/nhaut)
-         ENDDO
-         sig(1)=1.
-         sig(llm+1)=0.
-         quoi      = 1. + 2.* kappa
-         s( llm )  = 1.
-         s(llm-1) = quoi
-         IF( llm.gt.2 )  THEN
-            DO  ll = 2, llm-1
-               l         = llm+1 - ll
-               quand     = sig(l+1)/ sig(l)
-               s(l-1)    = quoi * (1.-quand) * s(l)  + quand * s(l+1)
-            ENDDO
-         END IF
-c
-         snorm=(1.-.5*sig(2)+kappa*(1.-sig(2)))*s(1)+.5*sig(2)*s(2)
-         DO l = 1, llm
-            s(l)    = s(l)/ snorm
-         ENDDO
-
-c-----------------------------------------------------------------------
-c   cas 2 on lit les options dans z2sig.def:
-c   ----------------------------------------
-
-      ELSE IF(ierr4.eq.0) then
+      open(99,file="z2sig.def",status='old',form='formatted',
+     s     iostat=ierr4)
+
+
+      autozlevs=.false.
+      PRINT *,'Auto-discretise vertical levels ?'
+      call getin("autozlevs",autozlevs)
+      write(*,*) " autozlevs = ", autozlevs
+
+      write(*,*)"Operate in kastprof mode?"
+      kastprof=.false.
+      call getin("kastprof",kastprof)
+      write(*,*)" kastprof = ",kastprof
+
+      print*,'kast=',kastprof
+
+      pceil=100.0 ! Pascals
+      PRINT *,'Ceiling pressure (Pa) ?'
+      call getin("pceil",pceil)
+      write(*,*) " pceil = ", pceil
+
+      if(autozlevs.and.iim.gt.1)then
+         print*,'autozlevs no good in 3D...'
+         call abort
+      endif
+
+      if(kastprof.and.iim.gt.1)then
+         print*,'kastprof no good in 3D...'
+         call abort
+      endif
+
+      psurf=610. ! default value for psurf
+      PRINT *,'Surface pressure (Pa) ?'
+      call getin("psurf",psurf)
+      write(*,*) " psurf = ",psurf
+
+      if(kastprof)then
+
+        sig(1)=1
+        do l=2,llm
+                                !sig(l)=1. - real(l-1)/real(llm) ! uses linear sigma spacing
+                                !sig(l)=exp(-real(l-1)*h/real(llm)) ! uses log sigma spacing
+                                !sig(l)=exp(-real(l-1)*Hmax/real(llm)) ! uses log sigma spacing
+           sig(l)=(pceil/psurf)**(real(l-1)/real(llm)) ! uses log sigma spacing
+           
+        end do
+        sig(llm+1)=0
+
+      elseIF(ierr4.eq.0)then
          PRINT*,'****************************'
          PRINT*,'Lecture de z2sig.def'
@@ -124,14 +113,30 @@
          CLOSE(99)
 
-         sig(1) =1
-         do l=2,llm
+
+         if(autozlevs)then
+            open(91,file="z2sig.def",form='formatted')
+            read(91,*) h
+            DO l=1,llm-2
+               read(91,*) Hmax
+            enddo
+            close(91)
+
+            print*,'Hmax = ',Hmax,' km'
+            print*,'Auto-shifting h in disvert.F to:'
+!            h = Hmax / log(psurf/100.0)
+            h = Hmax / log(psurf/pceil)
+            print*,'h = ',h,' km'
+        endif
+       
+        sig(1)=1
+        do l=2,llm
            sig(l) = 0.5 * ( exp(-zsig(l)/h) + exp(-zsig(l-1)/h) )
-         end do
-         sig(llm+1) =0
+        end do
+        sig(llm+1)=0
 
 c-----------------------------------------------------------------------
       ELSE
-         write(*,*) 'didn t you forget something ??? '
-         write(*,*) 'We need the file  z2sig.def ! (OR esasig.def) '
+         write(*,*) 'didn_t you forget something?'
+         write(*,*) 'We need the file  z2sig.def!'! (OR esasig.def) '
          stop
       ENDIF
@@ -206,5 +211,5 @@
       else
          bps(llm) = bps(llm-1)**2 / bps(llm-2) 
-         aps(llm) = 0.
+         aps(llm) = 0. ! what the hell is this???
       end if
 
@@ -213,4 +218,5 @@
       PRINT *,' APs'
       PRINT *,  aps
+
 
       DO l = 1, llm
Index: /trunk/LMDZ.GENERIC/libf/dyn3d/dynetat0.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/dynetat0.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/dynetat0.F	(revision 253)
@@ -51,4 +51,9 @@
       INTEGER ierr, nid, nvarid, nqold
       CHARACTER  str3*3,yes*1
+
+
+!     added by RW for test
+      real pmean,airetot
+      integer ij
 
 c-----------------------------------------------------------------------
@@ -421,4 +426,9 @@
      *rrage est differente de la valeur  dtinteg =',i4//)
 
+
+
+
+
+
       RETURN
       END
Index: /trunk/LMDZ.GENERIC/libf/dyn3d/gcm.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/gcm.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/gcm.F	(revision 253)
@@ -132,5 +132,5 @@
 ! flag to set/remove calls to groupeun
       logical callgroupeun
-      parameter (callgroupeun = .true.)
+      parameter (callgroupeun = .false.)
 
 !     added by RDW for tests without dynamics
@@ -138,4 +138,17 @@
       parameter (calldyn = .true.)
 
+!     added by RW for test
+!      real pmean,airetot
+
+!     added by FF for dissipation / energy conservation tests
+      logical dissip_conservative
+      parameter (dissip_conservative = .false.)
+      REAL ecin(ip1jmp1,llm),ecin0(ip1jmp1,llm)
+!     d (theta)/ d t (pot. temperature) due to the creation 
+!     of thermal energy by dissipation
+      REAL dtetaecdt(ip1jmp1,llm)
+      REAL vcont(ip1jm,llm),ucont(ip1jmp1,llm)
+      REAL vnat(ip1jm,llm),unat(ip1jmp1,llm)
+
 
 c-----------------------------------------------------------------------
@@ -151,9 +164,9 @@
       CALL iniadvtrac(nq,numvanle)
 
+
       CALL dynetat0("start.nc",nqmx,vcov,ucov,
      .              teta,q,masse,ps,phis, time_0)
 
       CALL defrun_new( 99, .TRUE. )
-
 
 c  on recalcule eventuellement le pas de temps
@@ -176,5 +189,4 @@
       CALL iniconst
       CALL inigeom
-
       CALL inifilr
 
@@ -192,5 +204,5 @@
       CALL exner_hyb( ip1jmp1, ps, p,beta, pks, pk, pkf )
 
-c
+
 c  numero de stockage pour les fichiers de redemarrage:
 
@@ -303,5 +315,4 @@
       CALL geopot  ( ip1jmp1, teta  , pk , pks,  phis  , phi   )
 
-
       if(calldyn)then
          CALL caldyn 
@@ -314,4 +325,6 @@
 c   -------------------------------------------------------------
 
+
+
       if (tracer) then
        IF( forward. OR . leapf )  THEN
@@ -360,4 +373,6 @@
      $            dv,du,dteta,dq,dp,vcov,ucov,teta,q,ps,masse,phis,
      $            finvmaold)
+          else
+             print*,'Currently no dynamics in this GCM...'
           endif
 
@@ -407,7 +422,11 @@
 c      ajout des tendances physiques:
 c      ------------------------------
+!        if(1.eq.2)then
           CALL addfi( nqmx, dtphys, leapf, forward   ,
      $                  ucov, vcov, teta , q   ,ps , masse,
      $                 dufi, dvfi, dhfi , dqfi ,dpfi  )
+!       else
+!          print*,'Currently no physics in this GCM...'
+!       endif
 c
        ENDIF
@@ -436,8 +455,27 @@
 c        Dissipation horizontale
 c        ~~~~~~~~~~~~~~~~~~~~~~~
+
+
+         if(dissip_conservative) then
+!     calculate kinetic energy before dissipation
+            call covcont(llm,ucov,vcov,ucont,vcont)
+            call enercin(vcov,ucov,vcont,ucont,ecin0)
+         end if
+
          CALL dissip(vcov,ucov,teta,p,dvdis,dudis,dhdis)
 
          CALL addit( ijp1llm,ucov ,dudis,ucov )
          CALL addit( ijmllm ,vcov ,dvdis,vcov )
+
+
+         if (dissip_conservative) then
+C           On rajoute la tendance due a la transform. Ec -> E therm. cree
+C           lors de la dissipation
+            call covcont(llm,ucov,vcov,ucont,vcont)
+            call enercin(vcov,ucov,vcont,ucont,ecin)
+            dtetaecdt(:,:) = (ecin0(:,:)-ecin(:,:))/ pk(:,:)
+            dhdis(:,:)     = dhdis(:,:) + dtetaecdt(:,:)
+         endif
+
          CALL addit( ijp1llm,teta ,dhdis,teta )
 
Index: /trunk/LMDZ.GENERIC/libf/dyn3d/iniadvtrac.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/iniadvtrac.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/iniadvtrac.F	(revision 253)
@@ -48,10 +48,9 @@
 
 
-!     MODIFICATION TO TEST WITHOUT TRACER ADVECTION BY RDW
-        !do iq=1,nq
-        !  iadv(iq)=0
-        !enddo
-        !print*,'TRACERS ARE NO LONGER ADVECTED IN THE GCM!!!!!!'
-
+!     MODIFICATION TO TEST OTHER SCHEMES BY RDW
+!        do iq=1,nq
+!           iadv(iq)=1
+!        enddo
+!        print*,'IADV SET TO 1 IN iniadvtrac!!!!'
 
         do iq=1,nq
Index: /trunk/LMDZ.GENERIC/libf/dyn3d/inidissip.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/inidissip.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/inidissip.F	(revision 253)
@@ -51,8 +51,15 @@
 c         FF 2004       
          if (pseudoalt(llm).lt.160.) then 
+!     currently disabled for the universal model!!!
              fac_mid=2  ! coeff  pour dissipation aux basses/moyennes altitudes
              fac_up=10 ! coeff multiplicateur pour dissipation hautes altitudes
              startalt=90. ! altitude en Km de la transition mid / up
              delta=20.! Intervalle (km) pour le changement mid / up
+
+!             fac_mid=1  ! coeff  pour dissipation aux basses/moyennes altitudes
+!             fac_up=1 ! coeff multiplicateur pour dissipation hautes altitudes
+!             startalt=100. ! altitude en Km de la transition mid / up
+!             delta=20.! Intervalle (km) pour le changement mid / up
+
          else ! thermosphere model
              fac_mid=2 ! coeff pour dissipation aux basses/moyennes altitudes
Index: /trunk/LMDZ.GENERIC/libf/dyn3d/lect_start_archive.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/lect_start_archive.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/lect_start_archive.F	(revision 253)
@@ -2,4 +2,5 @@
      &     t,ucov,vcov,ps,h,phisold_newgrid,
      &     q,qsurf,surfith,nid)
+
 c=======================================================================
 c
@@ -1102,4 +1103,8 @@
 c-----------------------------------------------------------------------
 !      write(*,*) 'Soil'
+
+      !print*,'Problem in lect_start_archive interpolating'
+      !print*,'to new resolution!!'
+
       ! Recast temperatures along soil depth, if necessary
       if (olddepthdef) then
@@ -1109,6 +1114,14 @@
         do i=1,imold+1
 	 do j=1,jmold+1
+
+            !if(i.gt.iip1 .or. j.gt.jjp1)then
+               !print*,'Problem in lect_start_archive interpolating'
+               !print*,'to new resolution!!'
+               !call abort
+            !endif
+
 	   ! copy values
-	   oldval(1)=tsurfS(i,j)
+	   oldval(1)=tsurfold(i,j)
+!	   oldval(1)=tsurfS(i,j)
 	   oldval(2:nsoilold+1)=tsoilold(i,j,1:nsoilold)
 	   ! build vertical coordinate
@@ -1142,5 +1155,6 @@
 	 do j=1,jmold+1
 	   ! copy values
-	   oldval(1)=tsurfS(i,j)
+	   oldval(1)=tsurfold(i,j)
+!	   oldval(1)=tsurfS(i,j)
 	   oldval(2:nsoilold+1)=tsoilold(i,j,1:nsoilold)
 	  ! interpolate
Index: /trunk/LMDZ.GENERIC/libf/dyn3d/logic.h
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/logic.h	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/logic.h	(revision 253)
@@ -3,8 +3,8 @@
 
       COMMON/logic/ purmats,physic,forward,leapf,apphys,grireg,
-     *  statcl,conser,apdiss,apdelq,saison,ecripar,fxyhypb,ysinus,hybrid
+     *  statcl,conser,apdiss,apdelq,saison,ecripar,fxyhypb,ysinus,hybrid,autozlevs
 
       LOGICAL purmats,physic,forward,leapf,apphys,grireg,statcl,conser,
-     * apdiss,apdelq,saison,ecripar,fxyhypb,ysinus,hybrid
+     * apdiss,apdelq,saison,ecripar,fxyhypb,ysinus,hybrid,autozlevs
 
 c-----------------------------------------------------------------------
Index: /trunk/LMDZ.GENERIC/libf/dyn3d/newstart.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/newstart.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/newstart.F	(revision 253)
@@ -154,4 +154,19 @@
       real :: MONS_coeffN ! coeff for northern hemisphere
 !      real,parameter :: icedepthmin=1.e-3 ! Ice begins at most at that depth
+
+!     added by RW for test
+      real pmean, phi0
+
+!     added by BC for equilibrium temperature startup
+      real teque
+
+!     added by BC for cloud fraction setup
+      REAL hice(ngridmx),cloudfrac(ngridmx,nlayermx)
+      REAL totalfrac(ngridmx)
+
+!     added by RW for nuketharsis
+      real fact1
+      real fact2
+
 
 c sortie visu pour les champs dynamiques
@@ -425,6 +440,7 @@
         CALL phyetat0 (fichnom,tab0,Lmodif,nsoilmx,nqmx,
      .        day_ini,time,
-     .        tsurf,tsoil,emis,q2,qsurf)
-        
+     .        tsurf,tsoil,emis,q2,qsurf,   !) ! temporary modif by RDW
+     .        cloudfrac,totalfrac,hice)
+
         ! copy albedo and soil thermal inertia
         do i=1,ngridmx
@@ -457,4 +473,5 @@
       write(*,*)
       write(*,*) 'flat : no topography ("aquaplanet")'
+      write(*,*) 'nuketharsis : no Tharsis bulge'
       write(*,*) 'bilball : uniform albedo and thermal inertia'
       write(*,*) 'coldspole : cold subsurface and high albedo at S.pole'
@@ -471,7 +488,11 @@
       write(*,*) 'watercapn : H20 ice on permanent N polar cap '
       write(*,*) 'watercaps : H20 ice on permanent S polar cap '
+      write(*,*) 'noacglac  : H2O ice across Noachis Terra'
       write(*,*) 'oborealis : H2O ice across Vastitas Borealis'
+      write(*,*) 'iceball   : Thick ice layer all over surface'
       write(*,*) 'wetstart  : start with a wet atmosphere'
-      write(*,*) 'isotherm : Isothermal Temperatures, wind set to zero'
+      write(*,*) 'isotherm  : Isothermal Temperatures, wind set to zero'
+      write(*,*) 'radequi   : Earth-like radiative equilibrium temperature
+     $ profile (lat-alt) and winds set to zero'
       write(*,*) 'coldstart : Start X K above the CO2 frost point and 
      $set wind to zero (assumes 100% CO2)'
@@ -479,12 +500,12 @@
       write(*,*) 'ptot : change total pressure'
       write(*,*) 'emis : change surface emissivity'
-      write(*,*) 'therm_ini_s: Set soil thermal inertia to reference sur
+      write(*,*) 'therm_ini_s : Set soil thermal inertia to reference sur
      &face values'
-      write(*,*) 'subsoilice_n: Put deep underground ice layer in northe
-     &rn hemisphere'
-      write(*,*) 'subsoilice_s: Put deep underground ice layer in southe
-     &rn hemisphere'
-      write(*,*) 'mons_ice: Put underground ice layer according to MONS-
-     &derived data'
+!      write(*,*) 'subsoilice_n : Put deep underground ice layer in northe
+!     &rn hemisphere'
+!      write(*,*) 'subsoilice_s : Put deep underground ice layer in southe
+!     &rn hemisphere'
+!      write(*,*) 'mons_ice : Put underground ice layer according to MONS-
+!     &derived data'
 
         write(*,*)
@@ -510,5 +531,5 @@
      &    ' were not set to zero ! => set calllott to F'                    
 
-c        Choice for surface pressure
+c        Choice of surface pressure
          yes=' '
          do while ((yes.ne.'y').and.(yes.ne.'n'))
@@ -533,6 +554,33 @@
          end if
 
-c       bilball : albedo, inertie thermique uniforme
-c       --------------------------------------------
+c       'nuketharsis : no tharsis bulge for Early Mars'
+c       ---------------------------------------------
+        else if (modif(1:len_trim(modif)) .eq. 'nuketharsis') then
+
+           DO j=1,jjp1        
+              DO i=1,iim
+                 ig=1+(j-2)*iim +i
+                 if(j.eq.1) ig=1
+                 if(j.eq.jjp1) ig=ngridmx
+
+                 fact1=(((rlonv(i)*180./pi)+100)**2 + 
+     &                (rlatu(j)*180./pi)**2)/65**2 
+                 fact2=exp( -fact1**2.5 )
+
+                 phis(i,j) = phis(i,j) - (phis(i,j)+4000.*g)*fact2
+
+!                 if(phis(i,j).gt.2500.*g)then
+!                    if(rlatu(j)*180./pi.gt.-80.)then ! avoid chopping south polar cap
+!                       phis(i,j)=2500.*g
+!                    endif
+!                 endif
+
+              ENDDO
+           ENDDO
+          CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,phis,phisfi)
+
+
+c       bilball : uniform albedo, thermal inertia
+c       -----------------------------------------
         else if (modif(1:len_trim(modif)) .eq. 'bilball') then
           write(*,*) 'constante albedo and iner.therm:'
@@ -654,4 +702,6 @@
              enddo
           enddo
+
+
 
 c        Correction pour la conservation des traceurs
@@ -908,4 +958,8 @@
 c      --------------------------------------------------
         else if (modif(1:len_trim(modif)) .eq. 'noglacier') then
+           if (igcm_h2o_ice.eq.0) then
+             write(*,*) "No water ice tracer! Can't use this option"
+             stop
+           endif
            do ig=1,ngridmx
              j=(ig-2)/iim +2
@@ -921,34 +975,89 @@
 c      --------------------------------------------------
         else if (modif(1:len_trim(modif)) .eq. 'watercapn') then
-           do ig=1,ngridmx
-             j=(ig-2)/iim +2
-              if(ig.eq.1) j=1
-              if (rlatu(j)*180./pi.gt.80.) then
-                   qsurf(ig,igcm_h2o_ice)=1.e5
-                   write(*,*) 'ig=',ig,'    H2O ice mass (kg/m2)= ',
-     &              qsurf(ig,igcm_h2o_ice)
-                   write(*,*)'     ==> Ice mesh South boundary (deg)= ',
-     &              rlatv(j)*180./pi
-                end if
-           enddo
+           if (igcm_h2o_ice.eq.0) then
+             write(*,*) "No water ice tracer! Can't use this option"
+             stop
+           endif
+
+           DO j=1,jjp1        
+              DO i=1,iim
+                 ig=1+(j-2)*iim +i
+                 if(j.eq.1) ig=1
+                 if(j.eq.jjp1) ig=ngridmx
+
+                 if (rlatu(j)*180./pi.gt.80.) then
+                    do isoil=1,nsoilmx
+                       ith(i,j,isoil) = 18000. ! thermal inertia
+                    enddo
+                   write(*,*)'     ==> Ice mesh North boundary (deg)= ',
+     &                   rlatv(j-1)*180./pi
+                 end if
+              ENDDO
+           ENDDO
+           CALL gr_dyn_fi(nsoilmx,iip1,jjp1,ngridmx,ith,ithfi)
+
+c$$$           do ig=1,ngridmx
+c$$$             j=(ig-2)/iim +2
+c$$$              if(ig.eq.1) j=1
+c$$$              if (rlatu(j)*180./pi.gt.80.) then
+c$$$
+c$$$                   qsurf(ig,igcm_h2o_ice)=1.e5
+c$$$                   qsurf(ig,igcm_h2o_vap)=0.0!1.e5
+c$$$
+c$$$                   write(*,*) 'ig=',ig,'    H2O ice mass (kg/m2)= ',
+c$$$     &              qsurf(ig,igcm_h2o_ice)
+c$$$
+c$$$                   write(*,*)'     ==> Ice mesh South boundary (deg)= ',
+c$$$     &              rlatv(j)*180./pi
+c$$$                end if
+c$$$           enddo
 
 c      watercaps : H20 ice on permanent southern cap
 c      -------------------------------------------------
         else if (modif(1:len_trim(modif)) .eq. 'watercaps') then
-           do ig=1,ngridmx
-               j=(ig-2)/iim +2
-               if(ig.eq.1) j=1
-               if (rlatu(j)*180./pi.lt.-80.) then
-                   qsurf(ig,igcm_h2o_ice)=1.e5
-                   write(*,*) 'ig=',ig,'   H2O ice mass (kg/m2)= ',
-     &              qsurf(ig,igcm_h2o_ice)
-                   write(*,*)'     ==> Ice mesh North boundary (deg)= ',
-     &              rlatv(j-1)*180./pi
-               end if
-           enddo
-
-c       oborealis : H2O ice across Vastitas Borealis
+           if (igcm_h2o_ice.eq.0) then
+              write(*,*) "No water ice tracer! Can't use this option"
+              stop
+           endif
+
+           DO j=1,jjp1        
+              DO i=1,iim
+                 ig=1+(j-2)*iim +i
+                 if(j.eq.1) ig=1
+                 if(j.eq.jjp1) ig=ngridmx
+
+                 if (rlatu(j)*180./pi.lt.-80.) then
+                    do isoil=1,nsoilmx
+                       ith(i,j,isoil) = 18000. ! thermal inertia
+                    enddo
+                   write(*,*)'     ==> Ice mesh South boundary (deg)= ',
+     &                   rlatv(j-1)*180./pi
+                 end if
+              ENDDO
+           ENDDO
+           CALL gr_dyn_fi(nsoilmx,iip1,jjp1,ngridmx,ith,ithfi)
+
+c$$$           do ig=1,ngridmx
+c$$$               j=(ig-2)/iim +2
+c$$$               if(ig.eq.1) j=1
+c$$$               if (rlatu(j)*180./pi.lt.-80.) then
+c$$$                  qsurf(ig,igcm_h2o_ice)=1.e5
+c$$$                  qsurf(ig,igcm_h2o_vap)=0.0 !1.e5
+c$$$
+c$$$                  write(*,*) 'ig=',ig,'   H2O ice mass (kg/m2)= ',
+c$$$     &                 qsurf(ig,igcm_h2o_ice)
+c$$$                  write(*,*)'     ==> Ice mesh North boundary (deg)= ',
+c$$$     &                 rlatv(j-1)*180./pi
+c$$$               end if
+c$$$           enddo
+
+
+c       noacglac : H2O ice across highest terrain
 c       --------------------------------------------
-        else if (modif(1:len_trim(modif)) .eq. 'oborealis') then
+        else if (modif(1:len_trim(modif)) .eq. 'noacglac') then
+           if (igcm_h2o_ice.eq.0) then
+             write(*,*) "No water ice tracer! Can't use this option"
+             stop
+           endif
           DO j=1,jjp1        
              DO i=1,iim
@@ -957,13 +1066,133 @@
                 if(j.eq.jjp1) ig=ngridmx
 
-                if(phis(i,j).lt.-4000.)then
-                    qsurf(ig,igcm_h2o_ice)=1.e5
-                    phis(i,j)=-4000.0
+                if(phis(i,j).gt.1000.*g)then
+                    alb(i,j) = 0.5 ! snow value
+                    do isoil=1,nsoilmx
+                       ith(i,j,isoil) = 18000. ! thermal inertia
+                       ! this leads to rnat set to 'ocean' in physiq.F90
+                       ! actually no, because it is soil not surface
+                    enddo
                 endif
              ENDDO
           ENDDO
+          CALL gr_dyn_fi(nsoilmx,iip1,jjp1,ngridmx,ith,ithfi)
+          CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,alb,albfi)
+          CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,phis,phisfi)
+
+
+
+c       oborealis : H2O oceans across Vastitas Borealis
+c       -----------------------------------------------
+        else if (modif(1:len_trim(modif)) .eq. 'oborealis') then
+           if (igcm_h2o_ice.eq.0) then
+             write(*,*) "No water ice tracer! Can't use this option"
+             stop
+           endif
+          DO j=1,jjp1        
+             DO i=1,iim
+                ig=1+(j-2)*iim +i
+                if(j.eq.1) ig=1
+                if(j.eq.jjp1) ig=ngridmx
+
+                if(phis(i,j).lt.-4000.*g)then
+!                if( (phis(i,j).lt.-4000.*g)
+!     &               .and. (rlatu(j)*180./pi.lt.0.) )then ! south hemisphere only
+!                    phis(i,j)=-8000.0*g ! proper ocean
+                    phis(i,j)=-4000.0*g ! scanty ocean
+
+                    alb(i,j) = 0.07 ! oceanic value
+                    do isoil=1,nsoilmx
+                       ith(i,j,isoil) = 18000. ! thermal inertia
+                       ! this leads to rnat set to 'ocean' in physiq.F90
+                       ! actually no, because it is soil not surface
+                    enddo
+                endif
+             ENDDO
+          ENDDO
+          CALL gr_dyn_fi(nsoilmx,iip1,jjp1,ngridmx,ith,ithfi)
+          CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,alb,albfi)
+          CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,phis,phisfi)
+
+c       iborealis : H2O ice in Northern plains
+c       --------------------------------------
+        else if (modif(1:len_trim(modif)) .eq. 'iborealis') then
+           if (igcm_h2o_ice.eq.0) then
+             write(*,*) "No water ice tracer! Can't use this option"
+             stop
+           endif
+          DO j=1,jjp1        
+             DO i=1,iim
+                ig=1+(j-2)*iim +i
+                if(j.eq.1) ig=1
+                if(j.eq.jjp1) ig=ngridmx
+
+                if(phis(i,j).lt.-4000.*g)then
+                   qsurf(ig,igcm_h2o_ice)=1.e3
+                endif
+             ENDDO
+          ENDDO
+          CALL gr_dyn_fi(nsoilmx,iip1,jjp1,ngridmx,ith,ithfi)
+          CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,alb,albfi)
+          CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,phis,phisfi)
+
+
+c       oceanball : H2O liquid everywhere
+c       ----------------------------
+        else if (modif(1:len_trim(modif)) .eq. 'oceanball') then
+           if (igcm_h2o_ice.eq.0) then
+             write(*,*) "No water ice tracer! Can't use this option"
+             stop
+           endif
+          DO j=1,jjp1        
+             DO i=1,iim
+                ig=1+(j-2)*iim +i
+                if(j.eq.1) ig=1
+                if(j.eq.jjp1) ig=ngridmx
+
+                qsurf(ig,igcm_h2o_vap)=0.0    ! for ocean, this is infinite source
+                qsurf(ig,igcm_h2o_ice)=0.0
+                alb(i,j) = 0.07 ! ocean value
+
+                do isoil=1,nsoilmx
+                   ith(i,j,isoil) = 18000. ! thermal inertia
+                   !ith(i,j,isoil) = 50. ! extremely low for test
+                   ! this leads to rnat set to 'ocean' in physiq.F90
+                enddo
+
+             ENDDO
+          ENDDO
+          CALL gr_dyn_fi(nsoilmx,iip1,jjp1,ngridmx,ith,ithfi)
+          CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,alb,albfi)
+          CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,phis,phisfi)
+
+c       iceball : H2O ice everywhere
+c       ----------------------------
+        else if (modif(1:len_trim(modif)) .eq. 'iceball') then
+           if (igcm_h2o_ice.eq.0) then
+             write(*,*) "No water ice tracer! Can't use this option"
+             stop
+           endif
+          DO j=1,jjp1        
+             DO i=1,iim
+                ig=1+(j-2)*iim +i
+                if(j.eq.1) ig=1
+                if(j.eq.jjp1) ig=ngridmx
+
+                qsurf(ig,igcm_h2o_vap)=-50.    ! for ocean, this is infinite source
+                qsurf(ig,igcm_h2o_ice)=50.     ! == to 0.05 m of oceanic ice
+                alb(i,j) = 0.6 ! ice albedo value
+
+                do isoil=1,nsoilmx
+                   !ith(i,j,isoil) = 18000. ! thermal inertia
+                   ! this leads to rnat set to 'ocean' in physiq.F90
+                enddo
+
+             ENDDO
+          ENDDO
+          CALL gr_dyn_fi(nsoilmx,iip1,jjp1,ngridmx,ith,ithfi)
+          CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,alb,albfi)
 
 c       isotherm : Isothermal temperatures and no winds
-c       ------------------------------------------------
+c       -----------------------------------------------
         else if (modif(1:len_trim(modif)) .eq. 'isotherm') then
 
@@ -994,4 +1223,33 @@
           call initial0(ngridmx*(llm+1),q2)
 
+c       radequi : Radiative equilibrium profile of temperatures and no winds
+c       --------------------------------------------------------------------
+        else if (modif(1:len_trim(modif)) .eq. 'radequi') then
+
+          write(*,*)'radiative equilibrium temperature profile'       
+
+          do ig=1, ngridmx
+             teque= 335.0-60.0*sin(latfi(ig))*sin(latfi(ig))-
+     &            10.0*cos(latfi(ig))*cos(latfi(ig))
+             tsurf(ig) = MAX(220.0,teque)
+          end do
+          do l=2,nsoilmx
+             do ig=1, ngridmx
+                tsoil(ig,l) = tsurf(ig)
+             end do
+          end do
+          DO j=1,jjp1
+             DO i=1,iim
+                Do l=1,llm
+                   teque=335.-60.0*sin(rlatu(j))*sin(rlatu(j))-
+     &                  10.0*cos(rlatu(j))*cos(rlatu(j))
+                   Tset(i,j,l)=MAX(220.0,teque)
+                end do
+             end do
+          end do
+          flagtset=.true.
+          call initial0(llm*ip1jmp1,ucov)
+          call initial0(llm*ip1jm,vcov)
+          call initial0(ngridmx*(llm+1),q2)
 
 c       coldstart : T set 1K above CO2 frost point and no winds
